.386
.model flat,stdcall
option casemap:none

include windows.inc
;include user32.inc
include kernel32.inc
include comctl32.inc
   
;includelib user32.lib
includelib kernel32.lib
includelib comctl32.lib
   
include debug.inc
includelib debug.lib

include D:\masm32\macros\macros.asm

WinMain 				proto :DWORD,:DWORD,:DWORD,:DWORD
ButtonProc				proto :DWORD,:DWORD,:DWORD,:DWORD

ID_BUTTON				equ 2000

.const
szButton				db "Button",0
szToolTips				db "Tooltips_class32",0
ClassName 				db "MainWinClass",0
AppName  				db "Main Window",0

.data
g_lpToolTipText			DWORD		0

.data?
g_hToolTipWnd			HWND		?
g_hButtonWnd			HWND 		?
g_hWnd					HWND		?
g_hInstance 			HINSTANCE 	?

.code

start:
	invoke GetModuleHandle, NULL
	mov    g_hInstance,eax
	        
    invoke InitCommonControls
	
	invoke WinMain, g_hInstance,NULL,NULL, SW_SHOWDEFAULT

	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,
						300,300,300,300,NULL,NULL,hInst,NULL
	mov   g_hWnd,eax
	
	invoke ShowWindow,g_hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,g_hWnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL ti:TOOLINFO
	
	mov eax,uMsg
	.if eax==WM_CREATE
		invoke CreateWindowEx,0,offset szButton,offset szButton,
			WS_CHILD or WS_VISIBLE,100,100,97,45,hWnd,ID_BUTTON,g_hInstance,NULL
		mov g_hButtonWnd,eax
		
		invoke SetWindowLong,g_hButtonWnd,GWL_WNDPROC,offset ButtonProc
		invoke SetWindowLong,g_hButtonWnd,GWL_USERDATA,eax
		
		invoke CreateWindowEx,NULL,offset szToolTips,NULL,TTS_ALWAYSTIP,\
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,g_hButtonWnd,NULL,g_hInstance,NULL
		mov g_hToolTipWnd,eax
		
		mov ti.cbSize,sizeof(TOOLINFO)
		mov ti.uFlags,TTF_IDISHWND or TTF_SUBCLASS 
		mov eax, g_hButtonWnd
		mov ti.hWnd,eax
		mov ti.uId,eax
		mov ti.lpszText,LPSTR_TEXTCALLBACK
		invoke SendMessage,g_hToolTipWnd,TTM_ADDTOOL,NULL,addr ti
		
		mov g_lpToolTipText,CTXT("ToolTip")
		

	.elseif eax==WM_DESTROY
		invoke GetWindowLong,g_hButtonWnd,GWL_USERDATA
		invoke SetWindowLong,g_hButtonWnd,GWL_WNDPROC,eax
		invoke DestroyWindow,g_hButtonWnd
		invoke DestroyWindow,g_hToolTipWnd
		invoke PostQuitMessage,NULL	
		
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	
	xor eax,eax
	ret
WndProc endp

ButtonProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	mov eax,uMsg
		
	.if eax == WM_NOTIFY
		mov	ecx,lParam
        mov eax,(NMHDR ptr [ecx]).code
        .if eax == TTN_NEEDTEXT
        	mov eax,g_lpToolTipText
        	mov (TOOLTIPTEXT ptr [ecx]).lpszText,eax
        .endif
        
	.endif 
	
	invoke GetWindowLong,g_hButtonWnd,GWL_USERDATA
	invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
	ret
ButtonProc endp

end start
